'------------------------------------------------------------------------------
' <autogenerated>
'     This code was generated by Measurement Studio.
'     Runtime Version: 1.1.4322.2032
'
'     Changes to this file may cause incorrect behavior and will be lost if 
'     the code is regenerated.
' </autogenerated>
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices


Public Class niDCPower
    Inherits Object
    Implements System.IDisposable
    
    Private _handle As System.IntPtr
    
    Private _disposed As Boolean = true
    
    '''<summary>
    '''Creates a new IVI instrument driver session to the power supply specified in Resource Name and returns a session handle you use to identify the power supply in all subsequent NI-DCPower function calls. This function also sends initialization commands to set the power supply to the state necessary for the operation of NI-DCPower. 
    '''
    '''To place the power supply in a known start-up state when creating a new session, set the Reset Device parameter to Yes. This action is equivalent to using the niDCPower_reset function.
    '''
    '''To open a session and leave the device in its existing configuration without passing through a transitional output state, set the Reset Device parameter to False, and immediately call niDCPower_Abort. To apply a new configuration without disrupting the output channels of the device, configure the device in Delayed Configuration mode as in the previous session changing only the desired settings, and then call niDCPower_Initiate.
    '''
    '''</summary>
    '''<param name="Resource_Name">
    '''Specifies the resource name assigned by Measurement &amp; Automation Explorer (MAX), for example "PXI1Slot3" where "PXI1Slot3" is an instrument's resource name. Resource name can also be a logical IVI name.
    '''</param>
    '''<param name="ID_Query">
    '''Specifies whether the device is queried to determine if the device is a valid instrument for NI-DCPower. The default value is Yes.
    '''
    '''
    '''</param>
    '''<param name="Reset_Device">
    '''Specifies whether to reset the power supply during the initialization procedure. The default is Yes.
    '''
    '''</param>
    '''<param name="Instrument_Handle">
    '''Returns a session handle that you use to identify the session in all subsequent NI-DCPower function calls.
    '''
    '''
    '''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''<summary>
    '''If Password is valid, this function creates a new IVI instrument driver session to the power supply specified in Resource Name and returns an instrument handle you use to identify the power supply in all subsequent NI-DCPower function calls. This function also sends initialization commands to set the power supply to the state necessary for the operation of NI-DCPower.
    '''
    '''Opening a calibration session always performs a reset. Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function.
    '''
    '''
    '''</summary>
    '''<param name="Resource_Name">
    '''Specifies the resource name assigned by Measurement &amp; Automation Explorer (MAX), for example "PXI1Slot3" where "PXI1Slot3" is an instrument's resource name. Resource Name can also be a logical IVI name. 
    '''</param>
    '''<param name="Password">
    '''Specifies the Password for opening a calibration session. Password can be a maximum of four alphanumeric characters.
    '''</param>
    '''<param name="Instrument_Handle">
    '''Returns a handle that you use to identify the session in all subsequent NI-DCPower function calls.
    '''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal Password As String)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.InitExtCal(Resource_Name, Password, Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''<summary>
    '''Creates a new IVI instrument driver session to the power supply specified in Resource Name and returns a session handle you use to identify the power supply in all subsequent NI-DCPower function calls. With this function, you can optionally set the initial state of the following session attributes: 
    '''
    '''NIDCPOWER_ATTR_SIMULATE, NIDCPOWER_ATTR_DRIVER_SETUP, NIDCPOWER_ATTR_RANGE_CHECK, NIDCPOWER_ATTR_QUERY_INSTRUMENT_STATUS, 
    '''NIDCPOWER_ATTR_CACHE, NIDCPOWER_ATTR_SIMULATE, and NIDCPOWER_ATTR_RECORD_COERCIONS.
    '''
    '''This function also sends initialization commands to set the power supply to the state necessary for NI-DCPower to operate. 
    '''
    '''To place the power supply in a known start-up state when creating a new session, set the Reset Device parameter to Yes. This action is equivalent to using the niDCPower_reset function.
    '''
    '''To open a session and leave the device in its existing configuration without passing through a transitional output state, set the Reset Device parameter to False, and immediately call niDCPower_Abort. To apply a new configuration without disrupting the output channels of the device, configure the device in Delayed Configuration mode as in the previous session changing only the desired settings, and then call niDCPower_Initiate.
    '''
    '''</summary>
    '''<param name="Resource_Name">
    '''Specifies the Resource Name assigned by Measurement &amp; Automation Explorer (MAX), for example "PXI1Slot3" where "PXI1Slot3" is an instrument's Resource Name. Resource Name can also be a logical IVI name. 
    '''</param>
    '''<param name="ID_Query">
    '''Specifies whether the device is queried to determine if the device is a valid instrument for NI-DCPower. The default value is VI_TRUE.
    '''</param>
    '''<param name="Reset_Device">
    '''Specifies whether to reset the power supply during the initialization procedure. The default value is VI_TRUE. 
    '''</param>
    '''<param name="Option_String">
    '''Specifies the initial value of certain attributes for the session. The syntax for optionString is a list of attributes with an assigned value where 1 is VI_TRUE and 0 is VI_FALSE. Each attribute/value combination is delimited with a comma, as shown in the following example:
    '''
    '''"Simulate=0,RangeCheck=1,QueryInstrStatus=0,Cache=1"
    '''
    '''If you do not wire this input or pass an empty string, the session assigns the default values, shown in the example, for these attributes. You do not have to specify a value for all the attributes. If you do not specify a value for an attribute, the default value is used. 
    '''</param>
    '''<param name="Instrument_Handle">
    '''Returns a handle that you use to identify the power supply in all subsequent NI-DCPower function calls.
    '''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean, ByVal Option_String As String)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Option_String, Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''<summary>
    '''Configures the voltage level for power generation of the specified output channel(s). The output channel must be enabled for the output voltage to change. Refer to the niDCPower_ConfigureOutputEnabled function for more information about enabling the output channel.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). 
    '''
    '''In Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
    '''</param>
    '''<param name="Level">
    '''Specifies the voltage level for the output channel generation in volts. When the specified voltage level is reached, the power supply actively regulates the generated voltage.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''
    '''</returns>
    Public Function ConfigureVoltageLevel(ByVal Channel_Name As String, ByVal Level As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureVoltageLevel(Me._handle, Channel_Name, Level)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the current limit and behavior of the specified output channel(s). The output channel must be enabled for the output to change. Refer to the niDCPower_ConfigureOutputEnabled function for more information about enabling output channels.
    '''
    '''
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). 
    '''
    '''In Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
    '''</param>
    '''<param name="Behavior">
    '''Specifies how the output should behave when the current limit is reached. 
    '''
    '''Defined Values: 
    '''
    '''- NIDCPOWER_VAL_CURRENT_REGULATE - The power supply controls the output current so that it does not exceed the current limit. Power continues to generate, even if the current limit has been reached.
    '''
    '''</param>
    '''<param name="Limit">
    '''Specifies the maximum current limit achievable before the specified Behavior activates. Valid values for current limit are defined by the current limit range and may be limited by the power source. 
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function ConfigureCurrentLimit(ByVal Channel_Name As String, ByVal Behavior As Integer, ByVal Limit As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureCurrentLimit(Me._handle, Channel_Name, Behavior, Limit)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Enables or disables output generation on the specified output channel(s) of the power supply. A voltage level must be set and the output channel must be enabled to generate power. Refer to the niDCPower_ConfigureVoltageLevel function for more information about setting the voltage level on an output channel.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). 
    '''
    '''In Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter. 
    '''</param>
    '''<param name="Enabled">
    '''Specifies whether the output is to be enabled (True) or disabled (False). 
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function ConfigureOutputEnabled(ByVal Channel_Name As String, ByVal Enabled As Boolean) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOutputEnabled(Me._handle, Channel_Name, System.Convert.ToUInt16(Enabled))
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Configures the output range of the specified output channel(s). If the value specified in Range does not match one of the range options, NI-DCPower coerces the value to the next highest valid range. Refer to the NI PXI-4110 section of the NI DC Power Supplies Help for the valid output ranges for your power supply.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies to which output channel(s) to apply this configuration value. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2). 
    '''
    '''In Immediate mode, multiple output channel configurations are performed sequentially based on the order specified in this parameter.
    '''</param>
    '''<param name="Range_Type">
    '''Specifies the type of the range: voltage or current.  
    '''
    '''Defined Values: 
    '''
    '''- Voltage - NI-DCPower configures the                               voltage range.  
    '''- Current - NI-DCPower configures the current range. 
    '''
    '''
    '''
    '''</param>
    '''<param name="Range">
    '''Specifies the requested Range. Refer to the NI PXI-4110 section the NI DC Power Supplies Help for more information about the valid values for this parameter.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function ConfigureOutputRange(ByVal Channel_Name As String, ByVal Range_Type As Integer, ByVal Range As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOutputRange(Me._handle, Channel_Name, Range_Type, Range)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Commits the configured settings to hardware and places the power supply in Immediate mode. Any configuration calls made after this function are applied immediately. To commit simultaneous hardware settings on multiple output channels, call the niDCPower_Abort function, configure the power supply, and call this function. 
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function Initiate() As Integer
        Dim pInvokeResult As Integer = PInvoke.Initiate(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Places the power supply in Delayed Configuration mode. Any configuration functions called after this function are not applied until the niDCPower_Initiate function is called. If power output is enabled when you call the niDCPower_Abort function, the output channels remain in their current state and continue providing power.
    '''
    '''Use the niDCPower_ConfigureOutputEnabled function to disable power output on a per channel basis. Use the niDCPower_reset function to disable output on all channels. While in Delayed Configuration mode, NI-DCPower performs only generic parameter validation. Any conflicting configuration calls are not validated until the niDCPower_Initiate function is called. If the same configuration is set multiple times to different values, NI-DCPower uses the last configuration call.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function Abort() As Integer
        Dim pInvokeResult As Integer = PInvoke.Abort(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Queries the specified output channel to determine if the output channel is currently in the state specified by Output State.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the output channel to query.
    '''</param>
    '''<param name="Output_State">
    '''Specifies the Output State of the output channel that is being queried. 
    '''
    '''Defined Values:
    '''
    '''- Constant Voltage - The power supply is maintaining a constant voltage by adjusting the current.
    '''- Constant Current - The power supply is maintaining a constant current by adjusting the voltage.
    '''
    '''
    '''
    '''</param>
    '''<param name="In_State">
    '''Returns whether the power supply output channel is in the specified state.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function QueryOutputState(ByVal Channel_Name As String, ByVal Output_State As Integer, ByRef In_State As Boolean) As Integer
        Dim In_StateAsUShort As System.UInt16
        Dim pInvokeResult As Integer = PInvoke.QueryOutputState(Me._handle, Channel_Name, Output_State, In_StateAsUShort)
        In_State = System.Convert.ToBoolean(In_StateAsUShort)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the measured value of either the voltage or current on the specified output channel. Each call to this function blocks other function calls until the hardware returns the Measurement. The Measurement speed of the power supply and the NIDCPOWER_ATTR_SAMPLES_TO_AVERAGE attribute dictate the length of time that a Measurement takes. To measure multiple output channels, use the niDCPower_MeasureMultiple function. 
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the output channel to measure.
    '''</param>
    '''<param name="Measurement_Type">
    '''Specifies whether a voltage or current value should be measured.
    '''
    '''Defined Values: 
    '''
    '''- Voltage - The power supply measures voltage.  
    '''- Current - The power supply measures current.
    '''</param>
    '''<param name="Measurement">
    '''Returns the value of the measurement, either in volts for voltage or amps for current.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function Measure(ByVal Channel_Name As String, ByVal Measurement_Type As Integer, ByRef Measurement As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.Measure(Me._handle, Channel_Name, Measurement_Type, Measurement)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns arrays of the measured voltage and current values on the specified output channel(s). Each call to this function blocks other function calls until the measurements are returned from the power supply. The order of the measurements returned in the array corresponds to the order of the specified output channels. The measurement speed of the power supply and the NIDCPOWER_ATTR_SAMPLES_TO_AVERAGE attribute dictates the length of time that a measurement takes. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the output channels to measure. You can specify multiple channels by using a channel list or a channel range. A channel list is a comma (,) separated sequence of channel names (e.g. 0,2 specifies channels 0 and 2). A channel range is a lower bound channel followed by a hyphen (-) or colon (:) followed by an upper bound channel (e.g. 0-2 specifies channels 0, 1, and 2).
    '''</param>
    '''<param name="Voltage_Measurements">
    '''Returns an array of voltage measurements. The measurements in the array are returned in the same order as the channels specified in Channel Name. Ensure that sufficient space has been allocated for the returned array.
    '''</param>
    '''<param name="Current_Measurements">
    '''Returns an array of current measurements. The measurements in the array are returned in the same order as the channels specified in Channel Name. Ensure that sufficient space has been allocated for the returned array.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function MeasureMultiple(ByVal Channel_Name As String, ByVal Voltage_Measurements() As Double, ByVal Current_Measurements() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.MeasureMultiple(Me._handle, Channel_Name, Voltage_Measurements, Current_Measurements)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Queries the maximum current limit on an output channel if the output channel is set to the specified Voltage Level.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the output channel to query.
    '''</param>
    '''<param name="Voltage_Level">
    '''Specifies the voltage level to use when calculating the Max Current Limit.
    '''</param>
    '''<param name="Max_Current_Limit">
    '''Returns the maximum current limit that can be set with the specified Voltage Level.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function QueryMaxCurrentLimit(ByVal Channel_Name As String, ByVal Voltage_Level As Double, ByRef Max_Current_Limit As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.QueryMaxCurrentLimit(Me._handle, Channel_Name, Voltage_Level, Max_Current_Limit)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Queries the maximum voltage level on an output channel if the output channel is set to the specified Current Limit.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the output channel to query.
    '''</param>
    '''<param name="Current_Limit">
    '''Specifies the current limit to use when calculating the Max Voltage Level.
    '''</param>
    '''<param name="Max_Voltage_Level">
    '''Returns the maximum voltage level that can be set on an output channel with the specified Current Limit.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function QueryMaxVoltageLevel(ByVal Channel_Name As String, ByVal Current_Limit As Double, ByRef Max_Voltage_Level As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.QueryMaxVoltageLevel(Me._handle, Channel_Name, Current_Limit, Max_Voltage_Level)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Queries the minimum current limit on an output channel if the output channel is set to the specified Voltage Level.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the output channel to query.
    '''</param>
    '''<param name="Voltage_Level">
    '''Specifies the voltage level to use when calculating the min Current Limit.
    '''</param>
    '''<param name="Min_Current_Limit">
    '''Returns the minimum current limit that can be set on an output channel with the specified Voltage Level.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function QueryMinCurrentLimit(ByVal Channel_Name As String, ByVal Voltage_Level As Double, ByRef Min_Current_Limit As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.QueryMinCurrentLimit(Me._handle, Channel_Name, Voltage_Level, Min_Current_Limit)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Closes the session specified in Instrument Handle and deallocates the resources that NI-DCPower reserved for calibration. Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function. If an error occurs before this function, Action defaults to Cancel.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Action">
    '''Specifies how to use the calibration values from this session as the session is closed. 
    '''
    '''Defined Values: 
    '''
    '''- Commit - The new calibration constants are stored in the EEPROM. 
    '''- Cancel - The old calibration constants are kept, and the new ones are discarded. 
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function CloseExtCal(ByVal Action As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CloseExtCal(Me._handle, Action)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Calculates the calibration constants for the voltage level for the specified output channel. This function compares the array in Requested Outputs to the array in Measured Outputs and calculates the calibration constants for the voltage level of the output channel. 
    '''
    '''Refer to the calibration procedure of the power supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called in an external calibration session.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the output channel to which these calibration settings apply.
    '''</param>
    '''<param name="Range">
    '''Specifies the input range used for these calibration settings.
    '''</param>
    '''<param name="Number_Of_Measurements">
    '''Specifies the number of elements in Requested Outputs and Measured Outputs.
    '''</param>
    '''<param name="Requested_Outputs">
    '''Specifies an array of the output values requested in the niDCPower_ConfigureVoltageLevel function.
    '''</param>
    '''<param name="Measured_Outputs">
    '''Specifies an array of the output values measured by an external precision digital multimeter.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function CalAdjustVoltageLevel(ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As System.UInt32, ByVal Requested_Outputs() As Double, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustVoltageLevel(Me._handle, Channel_Name, Range, Number_Of_Measurements, Requested_Outputs, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Calculates the calibration constants for the voltage measurements returned by the niDCPower_Measure function for the specified output channel. This function compares the array in Reported Outputs to the array in Measured Outputs and calculates the calibration constants for the voltage measurements returned by the niDCPower_Measure function. 
    '''
    '''Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called in an external calibration session.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the channel name to which these calibration settings apply.
    '''</param>
    '''<param name="Range">
    '''Specifies the input range used for these calibration settings. 
    '''</param>
    '''<param name="Number_Of_Measurements">
    '''Specifies the number of elements in Requested Outputs and Measured Outputs. 
    '''</param>
    '''<param name="Reported_Outputs">
    '''Specifies an array of the output values that were returned by the niDCPower_Measure function.
    '''</param>
    '''<param name="Measured_Outputs">
    '''Specifies an array of the output values measured by an external precision digital multimeter.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function CalAdjustVoltageMeasurement(ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As System.UInt32, ByVal Reported_Outputs() As Double, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustVoltageMeasurement(Me._handle, Channel_Name, Range, Number_Of_Measurements, Reported_Outputs, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Calculates the calibration constants for the current limit for the specified output channel and range. This function compares the array in Requested Outputs to the array in Measured Outputs and calculates the calibration constants for the current limit returned by the power supply. 
    '''
    '''Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called from an external calibration session. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the channel name to which these calibration settings apply.
    '''</param>
    '''<param name="Range">
    '''Specifies the input range used for these calibration settings. 
    '''</param>
    '''<param name="Number_Of_Measurements">
    '''Specifies the number of elements in Requested Outputs and Measured Outputs. 
    '''</param>
    '''<param name="Requested_Outputs">
    '''Specifies an array of the output values that were requested in the niDCPower_ConfigureCurrentLimit function.
    '''</param>
    '''<param name="Measured_Outputs">
    '''Specifies an array of the output values measured by an external precision digital multimeter.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function CalAdjustCurrentLimit(ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As System.UInt32, ByVal Requested_Outputs() As Double, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustCurrentLimit(Me._handle, Channel_Name, Range, Number_Of_Measurements, Requested_Outputs, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Calibrates the current measurements returned by the niDCPower_Measure function for the specified output channel. This function calculates the calibration constants for the array in Reported Outputs to the array in Measured Outputs and calculates the calibration constants for the current measurements returned by the niDCPower_Measure function. 
    '''
    '''Refer to the calibration procedure for the power supply you are calibrating for detailed instructions on the appropriate use of this function. This function can only be called in an external calibration session. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Channel_Name">
    '''Specifies the channel name to which these calibration settings apply.
    '''</param>
    '''<param name="Range">
    '''Specifies the input range used for these calibration settings.
    '''</param>
    '''<param name="Number_Of_Measurements">
    '''Specifies the number of elements in Reported Outputs and Measured Outputs.
    '''</param>
    '''<param name="Reported_Outputs">
    '''Specifies an array of the output values that were returned by the niDCPower_Measure function.
    '''</param>
    '''<param name="Measured_Outputs">
    '''Specifies an array of the output values measured by an external precision digital multimeter.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function CalAdjustCurrentMeasurement(ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As System.UInt32, ByVal Reported_Outputs() As Double, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustCurrentMeasurement(Me._handle, Channel_Name, Range, Number_Of_Measurements, Reported_Outputs, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Changes the Password that is required to initialize an external calibration session. The Password can be a maximum of four alphanumeric characters. If you call this function in a regular session, Password is changed immediately. If you call this function in an external calibration session, Password is changed only after you close the session using the niDCPower_CloseExtCal function with Action set to Commit.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Old_Password">
    '''Specifies the previous password used to protect the calibration values.
    '''</param>
    '''<param name="New_Password">
    '''Specifies the new password to use to protect the calibration values.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function ChangeExtCalPassword(ByVal Old_Password As String, ByVal New_Password As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.ChangeExtCalPassword(Me._handle, Old_Password, New_Password)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the recommended maximum interval, in Months, between external calibrations.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Months">
    '''Specifies the recommended maximum interval, in Months, between external calibrations in months.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function GetExtCalRecommendedInterval(ByRef Months As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetExtCalRecommendedInterval(Me._handle, Months)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the date and time of the last successful calibration. The time returned is 24-hour (military) local time; for example, if the power supply was calibrated at 2:30 PM, this function returns 14 for Hours and 30 for Minutes.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Year">
    '''Returns the Year in which the power supply was last calibrated. 
    '''</param>
    '''<param name="Month">
    '''Returns the Month in which the power supply was last calibrated.
    '''</param>
    '''<param name="Day">
    '''Returns returns the Day on which the power supply was last calibrated. 
    '''</param>
    '''<param name="Hour">
    '''Returns the Hour (in 24-hour time) in which the power supply was last calibrated.
    '''</param>
    '''<param name="Minute">
    '''Returns the Minute in which the power supply was last calibrated.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function GetExtCalLastDateAndTime(ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetExtCalLastDateAndTime(Me._handle, Year, Month, Day, Hour, Minute)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the maximum number of characters that can be used to store user-defined information in the power supply onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Info_Size">
    '''Returns the number of characters that can be stored in the power supply onboard EEPROM.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function GetCalUserDefinedInfoMaxSize(ByRef Info_Size As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetCalUserDefinedInfoMaxSize(Me._handle, Info_Size)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Stores a user-defined string of characters in the power supply onboard EEPROM. If the string is longer than the maximum allowable size, it is truncated. This function overwrites any existing user-defined information.
    '''
    '''If you call this function in a regular session, Info is immediately changed. If you call this function in an external calibration session, Info is changed only after you close the session using the niDCPower_CloseExtCal function with Action set to Commit.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Info">
    '''Specifies the string to store in the power supply onboard EEPROM.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function SetCalUserDefinedInfo(ByVal Info As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.SetCalUserDefinedInfo(Me._handle, Info)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the user-defined information in the power supply onboard EEPROM.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Info">
    '''Returns the user-defined information stored in the power supply onboard EEPROM.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function GetCalUserDefinedInfo(ByVal Info As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetCalUserDefinedInfo(Me._handle, Info)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the current onboard Temperature, in degrees Celsius, of the power supply.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Temperature">
    '''Returns the onboard Temperature, in degrees Celsius, of the power supply.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function ReadCurrentTemperature(ByRef Temperature As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ReadCurrentTemperature(Me._handle, Temperature)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the onboard Temperature of the power supply, in degrees Celsius, during the last successful external calibration.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument calibration session. Instrument Handle is obtained from the niDCPower_InitExtCal function.
    '''</param>
    '''<param name="Temperature">
    '''Returns the onboard Temperature of the power supply, in degrees Celsius, during the last successful external calibration.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function GetExtCalLastTemp(ByRef Temperature As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetExtCalLastTemp(Me._handle, Temperature)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Places the power supply in a quiescent state where it has minimal or no impact on the system to which it is connected. The power output and all exported signals are disabled. This function performs the same actions as the niDCPower_reset function. 
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function Disable() As Integer
        Dim pInvokeResult As Integer = PInvoke.Disable(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Resets the power supply to a reset state. The function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in Immediate mode.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function reset() As Integer
        Dim pInvokeResult As Integer = PInvoke.reset(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Resets the power supply to a reset state. The function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in Immediate mode. 
    '''
    '''Performs a hard reset on the device and the driver software. This function has the same functionality as using reset in Measurement &amp; Automation Explorer.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function ResetDevice() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetDevice(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Performs the power supply self-test routine and returns the test result(s). Calling this function implicitly calls the niDCPower_reset function.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Self_Test_Result">
    '''Returns the value result from the power supply self-test. 0 indicates success. 
    '''</param>
    '''<param name="Self_Test_Message">
    '''Returns the self-test result message. The size of this array must be at least 256 bytes.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function self_test(ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.self_test(Me._handle, Self_Test_Result, Self_Test_Message)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the revision information of NI-DCPower and the power supply firmware.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Instrument_Driver_Revision">
    '''Returns the driver revision information for NI-DCPower.
    '''</param>
    '''<param name="Firmware_Revision">
    '''Returns firmware revision information for the power supply you are using. The size of this array must be at least 256 bytes.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function revision_query(ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.revision_query(Me._handle, Instrument_Driver_Revision, Firmware_Revision)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Resets the power supply to a reset state. This function disables power generation, resets session attributes to their default values, clears errors such as overtemperature and unexpected loss of auxiliary power, commits the session attributes, and leaves the session in Immediate mode. In addition to exhibiting the behavior of the niDCPower_reset function, this function can assign user-defined default values for configurable attributes from the IVI configuration.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function ResetWithDefaults() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetWithDefaults(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Retrieves the output Channel Name that corresponds to the requested Index. Use the NIDCPOWER_ATTR_CHANNEL_COUNT attribute to determine the upper bound of valid values for Index. 
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Index">
    '''Specifies which output channel name to return. The index values begin at 1.
    '''
    '''</param>
    '''<param name="Buffer_Size">
    '''Specifies the number of bytes in the ViChar array you specify for Channel Name. If the Channel Name, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7.
    '''
    '''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
    '''
    '''If you pass 0, you can pass VI_NULL for Channel Name.
    '''</param>
    '''<param name="Channel_Name">
    '''Returns the the output channel name that corresponds to Index.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function GetChannelName(ByVal Index As Integer, ByVal Buffer_Size As Integer, ByVal Channel_Name As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetChannelName(Me._handle, Index, Buffer_Size, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Returns the coercion information associated with the IVI session and clears the earliest instance in which NI-DCPower coerced a value you specified.
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Buffer_Size">
    '''Specifies the number of bytes in the ViChar array you specify for Coercion Record. If the next Coercion Record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is 123456 and the buffer size is 4, the function places 123 into the buffer and returns 7.
    '''
    '''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
    '''
    '''If you pass 0, you can pass VI_NULL for Coercion Record.
    '''</param>
    '''<param name="Coercion_Record">
    '''Returns the next Coercion Record for the IVI session. If there are no Coercion Records, the function returns an empty string.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function GetNextCoercionRecord(ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetNextCoercionRecord(Me._handle, Buffer_Size, Coercion_Record)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''Clears the list of current interchange warnings.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function ClearInterchangeWarnings() As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearInterchangeWarnings(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order.  To do so requires ensuring that each test module completely configures the state of each instrument it uses.  If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module.  If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change.  This change in behavior is generally instrument specific and represents an interchangeability problem.
    '''
    '''You can use this function to test for such cases.  After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations.  By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules.
    '''
    '''This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings.  If you want to guarantee that the niPower_GetNextInterchangeWarning function only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings.  You can clear the interchangeability warnings list by repeatedly calling the niPower_GetNextInterchangeWarning function until no more interchangeability warnings are returned.  If you are not interested in the content of those warnings, you can call the niPower_ClearInterchangeWarnings function.
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function ResetInterchangeCheck() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetInterchangeCheck(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''<summary>
    '''This function returns the interchangeability warning associated with the IVI session. It retrieves and clears the earliest instance in which the class driver recorded an interchangeability warning. Interchangeability warnings indicate that using your application with a different power supply may cause a different behavior. 
    '''
    '''NI-DCPower performs interchangeability checking when Interchange Check is set to TRUE. This function returns an empty string in warning if no interchangeability warnings remain for the session. In general, NI-DCPower generates interchangeability warnings when an attribute that affects the behavior of the power supply is in a state that you did not specify.
    '''
    '''
    '''</summary>
    '''<param name="Instrument_Handle">
    '''Identifies a particular instrument session. Instrument Handle is obtained from the niDCPower_init or the niDCPower_InitWithOptions function.
    '''</param>
    '''<param name="Buffer_Size">
    '''Specifies the number of bytes in the ViChar array you specify for Coercion Record. If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies (buffer size - 1) bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the Buffer Size you must pass to get the entire value. For example, if the value is 123456 and the Buffer Size is 4, the function places 123 into the buffer and returns 7.
    '''
    '''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
    '''
    '''If you pass 0, you can pass VI_NULL for Coercion Record.
    '''</param>
    '''<param name="Interchange_Warning">
    '''Returns the next Interchange Warning for the IVI session. If there are no Interchange Warnings, the function returns an empty string.
    '''</param>
    '''<returns>
    '''Returns the status code of this operation.  The status code  either indicates success or describes an error or warning condition.  You examine the status code from each call to an instrument driver function to determine if an error occurred.
    '''
    '''If the current value of the return buffer, including the terminating NUL byte, is larger than the size you indicate in the Buffer Size parameter, the function copies Buffer Size - 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7.
    '''
    '''To obtain a text description of the status code, call niDCPower_error_message. To obtain additional information concerning the error condition, call niDCPower_GetError.  To clear the error information from the driver, call the niDCPower_ClearError function.
    '''</returns>
    Public Function GetNextInterchangeWarning(ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetNextInterchangeWarning(Me._handle, Buffer_Size, Interchange_Warning)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
        Me.Dispose(true)
        System.GC.SuppressFinalize(Me)
    End Sub
    
    Private Overloads Sub Dispose(ByVal disposing As Boolean)
        If (Me._disposed = false) Then
            PInvoke.close(Me._handle)
            Me._handle = System.IntPtr.Zero
        End If
        Me._disposed = true
    End Sub
    
    Protected Overrides Sub Finalize()
        Me.Dispose(false)
    End Sub
    
    Public Overloads Sub SetInt32(ByVal propertyId As niDCPowerProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Integer)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetInt32(ByVal propertyId As niDCPowerProperties, ByVal val As Integer)
        Me.SetInt32(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetInt32(ByVal propertyId As niDCPowerProperties, ByVal repeatedCapabilityOrChannel As String) As Integer
        Dim val As Integer
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return val
    End Function
    
    Public Overloads Function GetInt32(ByVal propertyId As niDCPowerProperties) As Integer
        Return Me.GetInt32(propertyId, "")
    End Function
    
    Public Overloads Sub SetDouble(ByVal propertyId As niDCPowerProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Double)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetDouble(ByVal propertyId As niDCPowerProperties, ByVal val As Double)
        Me.SetDouble(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetDouble(ByVal propertyId As niDCPowerProperties, ByVal repeatedCapabilityOrChannel As String) As Double
        Dim val As Double
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return val
    End Function
    
    Public Overloads Function GetDouble(ByVal propertyId As niDCPowerProperties) As Double
        Return Me.GetDouble(propertyId, "")
    End Function
    
    Public Overloads Sub SetBoolean(ByVal propertyId As niDCPowerProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Boolean)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), System.Convert.ToUInt16(val)))
    End Sub
    
    Public Overloads Sub SetBoolean(ByVal propertyId As niDCPowerProperties, ByVal val As Boolean)
        Me.SetBoolean(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetBoolean(ByVal propertyId As niDCPowerProperties, ByVal repeatedCapabilityOrChannel As String) As Boolean
        Dim val As System.UInt16
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return System.Convert.ToBoolean(val)
    End Function
    
    Public Overloads Function GetBoolean(ByVal propertyId As niDCPowerProperties) As Boolean
        Return Me.GetBoolean(propertyId, "")
    End Function
    
    Public Overloads Sub SetString(ByVal propertyId As niDCPowerProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As String)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetString(ByVal propertyId As niDCPowerProperties, ByVal val As String)
        Me.SetString(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetString(ByVal propertyId As niDCPowerProperties, ByVal repeatedCapabilityOrChannel As String) As String
        Dim newVal As System.Text.StringBuilder = New System.Text.StringBuilder(512)
        Dim size As Integer = PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), 512, newVal)
        If (size < 0) Then
            PInvoke.ThrowError(Me._handle, size)
        Else
            If (size > 0) Then
                newVal.Capacity = size
                PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), size, newVal))
            End If
        End If
        Return newVal.ToString
    End Function
    
    Public Overloads Function GetString(ByVal propertyId As niDCPowerProperties) As String
        Return Me.GetString(propertyId, "")
    End Function
    
    Private Class PInvoke
        
        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_init", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function init (ByVal Resource_Name As String, ByVal ID_Query As System.UInt16, ByVal Reset_Device As System.UInt16, ByRef Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_InitExtCal", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function InitExtCal (ByVal Resource_Name As String, ByVal Password As String, ByRef Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_InitWithOptions", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function InitWithOptions (ByVal Resource_Name As String, ByVal ID_Query As System.UInt16, ByVal Reset_Device As System.UInt16, ByVal Option_String As String, ByRef Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureVoltageLevel", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ConfigureVoltageLevel (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Level As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureCurrentLimit", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ConfigureCurrentLimit (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Behavior As Integer, ByVal Limit As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureOutputEnabled", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ConfigureOutputEnabled (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Enabled As System.UInt16) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ConfigureOutputRange", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ConfigureOutputRange (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range_Type As Integer, ByVal Range As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_Initiate", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function Initiate (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_Abort", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function Abort (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_QueryOutputState", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function QueryOutputState (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Output_State As Integer, ByRef In_State As System.UInt16) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_Measure", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function Measure (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Measurement_Type As Integer, ByRef Measurement As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_MeasureMultiple", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function MeasureMultiple (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, <[In], Out> Voltage_Measurements As Double(), <[In], Out> Current_Measurements As Double()) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_QueryMaxCurrentLimit", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function QueryMaxCurrentLimit (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Voltage_Level As Double, ByRef Max_Current_Limit As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_QueryMaxVoltageLevel", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function QueryMaxVoltageLevel (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Current_Limit As Double, ByRef Max_Voltage_Level As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_QueryMinCurrentLimit", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function QueryMinCurrentLimit (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Voltage_Level As Double, ByRef Min_Current_Limit As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_CloseExtCal", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function CloseExtCal (ByVal Instrument_Handle As System.IntPtr, ByVal Action As Integer) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_CalAdjustVoltageLevel", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function CalAdjustVoltageLevel (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As System.UInt32, ByVal Requested_Outputs As Double(), ByVal Measured_Outputs As Double()) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_CalAdjustVoltageMeasurement", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function CalAdjustVoltageMeasurement (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As System.UInt32, ByVal Reported_Outputs As Double(), ByVal Measured_Outputs As Double()) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_CalAdjustCurrentLimit", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function CalAdjustCurrentLimit (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As System.UInt32, ByVal Requested_Outputs As Double(), ByVal Measured_Outputs As Double()) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_CalAdjustCurrentMeasurement", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function CalAdjustCurrentMeasurement (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Range As Double, ByVal Number_Of_Measurements As System.UInt32, ByVal Reported_Outputs As Double(), ByVal Measured_Outputs As Double()) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ChangeExtCalPassword", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ChangeExtCalPassword (ByVal Instrument_Handle As System.IntPtr, ByVal Old_Password As String, ByVal New_Password As String) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetExtCalRecommendedInterval", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetExtCalRecommendedInterval (ByVal Instrument_Handle As System.IntPtr, ByRef Months As Integer) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetExtCalLastDateAndTime", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetExtCalLastDateAndTime (ByVal Instrument_Handle As System.IntPtr, ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetCalUserDefinedInfoMaxSize", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetCalUserDefinedInfoMaxSize (ByVal Instrument_Handle As System.IntPtr, ByRef Info_Size As Integer) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_SetCalUserDefinedInfo", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function SetCalUserDefinedInfo (ByVal Instrument_Handle As System.IntPtr, ByVal Info As String) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetCalUserDefinedInfo", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetCalUserDefinedInfo (ByVal Instrument_Handle As System.IntPtr, ByVal Info As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ReadCurrentTemperature", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ReadCurrentTemperature (ByVal Instrument_Handle As System.IntPtr, ByRef Temperature As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetExtCalLastTemp", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetExtCalLastTemp (ByVal Instrument_Handle As System.IntPtr, ByRef Temperature As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_Disable", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function Disable (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_reset", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function reset (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ResetDevice", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ResetDevice (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_self_test", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function self_test (ByVal Instrument_Handle As System.IntPtr, ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_revision_query", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function revision_query (ByVal Instrument_Handle As System.IntPtr, ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ResetWithDefaults", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ResetWithDefaults (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetChannelName", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetChannelName (ByVal Instrument_Handle As System.IntPtr, ByVal Index As Integer, ByVal Buffer_Size As Integer, ByVal Channel_Name As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetNextCoercionRecord", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetNextCoercionRecord (ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ClearInterchangeWarnings", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ClearInterchangeWarnings (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_ResetInterchangeCheck", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function ResetInterchangeCheck (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetNextInterchangeWarning", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetNextInterchangeWarning (ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_close", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function close (ByVal Instrument_Handle As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_error_message", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function error_message (ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message_2 As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViInt32", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetAttributeViInt32 (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Integer) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViReal64", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetAttributeViReal64 (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViString", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetAttributeViString (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Buffer_Size As Integer, ByVal Attribute_Value As System.Text.StringBuilder) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViBoolean", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetAttributeViBoolean (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.UInt16) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetAttributeViSession", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetAttributeViSession (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViInt32", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function SetAttributeViInt32 (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Integer) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViReal64", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function SetAttributeViReal64 (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Double) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViString", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function SetAttributeViString (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As String) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViBoolean", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function SetAttributeViBoolean (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.UInt16) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_SetAttributeViSession", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function SetAttributeViSession (ByVal Instrument_Handle As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.IntPtr) As Integer
End Function

        <DllImport ("niDCPower_32.dll", EntryPoint:="niDCPower_GetError", CallingConvention:=CallingConvention.Cdecl)> _
Public Shared Function GetError (ByVal Instrument_Handle As System.IntPtr, ByRef Code As Integer, ByVal BufferSize As Integer, ByVal Description As System.Text.StringBuilder) As Integer
End Function

        Public Shared Function TestForError(ByVal handle As System.IntPtr, ByVal status As Integer) As Integer
            If (status < 0) Then
                PInvoke.ThrowError(handle, status)
            End If
            Return status
        End Function
        
        Public Shared Function ThrowError(ByVal handle As System.IntPtr, ByVal code As Integer) As Integer
            Dim status As Integer
            Dim size As Integer = PInvoke.GetError(handle, status, 0, Nothing)
            Dim msg As System.Text.StringBuilder = New System.Text.StringBuilder
            If (size >= 0) Then
                msg.Capacity = size
                PInvoke.GetError(handle, status, size, msg)
            End If
            Throw New System.Runtime.InteropServices.ExternalException(msg.ToString, code)
        End Function
    End Class
End Class

Public Class niDCPowerConstants
    
    Public Const RangeCurrent As Integer = 0
    
    Public Const MeasureCurrent As Integer = 0
    
    Public Const OutputConstantVoltage As Integer = 0
    
    Public Const Internal As Integer = 1003
    
    Public Const OutputConstantCurrent As Integer = 1
    
    Public Const Cancel As Integer = 1001
    
    Public Const Commit As Integer = 1002
    
    Public Const RangeVoltage As Integer = 1
    
    Public Const Auxiliary As Integer = 1004
    
    Public Const CurrentRegulate As Integer = 0
    
    Public Const Automatic As Integer = 1005
    
    Public Const MeasureVoltage As Integer = 1
End Class

Public Enum niDCPowerProperties
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    NidcpowerAttrRangeCheck = 1050002
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    NidcpowerAttrQueryInstrumentStatus = 1050003
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    NidcpowerAttrCache = 1050004
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    NidcpowerAttrSimulate = 1050005
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    NidcpowerAttrRecordCoercions = 1050006
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    NidcpowerAttrInterchangeCheck = 1050021
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrSpecificDriverDescription = 1050514
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrSpecificDriverPrefix = 1050302
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrSpecificDriverVendor = 1050513
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrSpecificDriverRevision = 1050551
    
    '''<summary>
    '''System.Int32
    '''</summary>
    NidcpowerAttrSpecificDriverClassSpecMajorVersion = 1050515
    
    '''<summary>
    '''System.Int32
    '''</summary>
    NidcpowerAttrSpecificDriverClassSpecMinorVersion = 1050516
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrSupportedInstrumentModels = 1050327
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrGroupCapabilities = 1050401
    
    '''<summary>
    '''System.Int32
    '''</summary>
    NidcpowerAttrChannelCount = 1050203
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrInstrumentManufacturer = 1050511
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrInstrumentModel = 1050512
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrInstrumentFirmwareRevision = 1050510
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrLogicalName = 1050305
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrIoResourceDescriptor = 1050304
    
    '''<summary>
    '''System.String
    '''</summary>
    NidcpowerAttrDriverSetup = 1050007
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    NidcpowerAttrOutputEnabled = 1250006
    
    '''<summary>
    '''System.Double
    '''</summary>
    NidcpowerAttrCurrentLimit = 1250005
    
    '''<summary>
    '''System.Double
    '''</summary>
    NidcpowerAttrVoltageLevel = 1250001
    
    '''<summary>
    '''System.Int32
    '''</summary>
    NidcpowerAttrPowerSource = 1150000
    
    '''<summary>
    '''System.Int32
    '''</summary>
    NidcpowerAttrPowerSourceInUse = 1150001
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    NidcpowerAttrAuxiliaryPowerSourceAvailable = 1150002
    
    '''<summary>
    '''System.Int32
    '''</summary>
    NidcpowerAttrSamplesToAverage = 1150003
    
    '''<summary>
    '''System.Boolean
    '''</summary>
    NidcpowerAttrResetAverageBeforeMeasurement = 1150006
    
    '''<summary>
    '''System.Double
    '''</summary>
    NidcpowerAttrCurrentLimitRange = 1150004
End Enum
